/* ---------------------------------------------------- */
/*  Generated by Enterprise Architect Version 13.0 		*/
/*  Created On : 21-11-2017 13:53:08 				*/
/*  DBMS       : DB2 						*/
/* ---------------------------------------------------- */

/* Drop Tables */

DROP TABLE Cities
;

DROP TABLE Games
;

DROP TABLE Groups
;

DROP TABLE KindsOfGames
;

DROP TABLE KindsOfUsers
;

DROP TABLE Users
;

DROP TABLE Words
;

/* Create Tables */

CREATE TABLE Cities
(
	PSC INTEGER NOT NULL,
	Name VARCHAR(100) NOT NULL
)
;

CREATE TABLE Games
(
	Comment varchar(255) NULL,
	Date DATE NOT NULL,
	HH INTEGER NOT NULL,
	KindOfGame varchar(50) NOT NULL,
	Lives INTEGER NULL,
	MM INTEGER NOT NULL,
	Original_HH INTEGER NULL,
	Original_MM INTEGER NULL,
	Original_SS INTEGER NULL,
	Score INTEGER NOT NULL,
	SS INTEGER NOT NULL,
	ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY,
	UserID INTEGER NOT NULL,
	GroupID INTEGER NOT NULL
)
;

CREATE TABLE Groups
(
	Comment varchar(255) NULL,
	GroupName varchar(50) NOT NULL,
	ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY
)
;

CREATE TABLE KindsOfGames
(
	Kind VARCHAR(50) NOT NULL,
	Comment VARCHAR(255) NULL
)
;

CREATE TABLE KindsOfUsers
(
	Kind VARCHAR(50) NOT NULL,
	Comment VARCHAR(255) NULL
)
;

CREATE TABLE Users
(
	Street varchar(65) NULL,
	Ban CHARACTER(1) NOT NULL DEFAULT '0',
	Email varchar(50) NOT NULL,
	FirstName varchar(30) NOT NULL,
	KindOfUser varchar(50) NOT NULL,
	LastName varchar(40) NOT NULL,
	Password varchar(150) NOT NULL,
	Picture BLOB NULL,
	Pseudonym varchar(30) NOT NULL,
	TelephoneNumber DECIMAL(9) NULL,
	ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY,
	PSC INTEGER NULL,
	Deleted CHARACTER(1) NOT NULL DEFAULT '0'
)
;

CREATE TABLE Words
(
	Comment varchar(255) NULL,
	Word varchar(50) NOT NULL,
	GroupID INTEGER NOT NULL
)
;

/* Create Primary Keys, Indexes, Uniques, Checks */

ALTER TABLE Cities ADD CONSTRAINT PK_Cities
	PRIMARY KEY (PSC)
;

ALTER TABLE Games ADD CONSTRAINT PK_Game
	PRIMARY KEY (ID)
;

CREATE INDEX IXFK_Games_KindsOfGames ON Games (KindOfGame ASC)
;

ALTER TABLE Groups ADD CONSTRAINT PK_Group
	PRIMARY KEY (ID)
;

ALTER TABLE KindsOfGames ADD CONSTRAINT PK_KindsOfGames
	PRIMARY KEY (Kind)
;

ALTER TABLE KindsOfUsers ADD CONSTRAINT PK_KindsOfUsers
	PRIMARY KEY (Kind)
;

ALTER TABLE Users ADD CONSTRAINT PK_User
	PRIMARY KEY (ID)
;

CREATE INDEX IXFK_Users_Cities ON Users (PSC ASC)
;

CREATE INDEX IXFK_Users_KindsOfUsers ON Users (KindOfUser ASC)
;

ALTER TABLE Words ADD CONSTRAINT PK_Word
	PRIMARY KEY (Word)
;

/* Create Foreign Key Constraints */

ALTER TABLE Games ADD CONSTRAINT FK_Games_KindsOfGames
	FOREIGN KEY (KindOfGame) REFERENCES KindsOfGames (Kind) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE Games ADD CONSTRAINT FK_Game_has
	FOREIGN KEY (UserID) REFERENCES Users (ID) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE Games ADD CONSTRAINT FK_Game_belongs
	FOREIGN KEY (GroupID) REFERENCES Groups (ID) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE Users ADD CONSTRAINT FK_Users_Cities
	FOREIGN KEY (PSC) REFERENCES Cities (PSC) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE Users ADD CONSTRAINT FK_Users_KindsOfUsers
	FOREIGN KEY (KindOfUser) REFERENCES KindsOfUsers (Kind) ON DELETE No Action ON UPDATE No Action
;

ALTER TABLE Words ADD CONSTRAINT FK_Word_contains
	FOREIGN KEY (GroupID) REFERENCES Groups (ID) ON DELETE No Action ON UPDATE No Action
;

/* Create Table Comments */

COMMENT ON COLUMN Users.Deleted
	IS ''''''
;
